# ** global variables **

# in general do not want to use


#example
#import sys
#a = 5
#x = 2
# # method 1: local variables
# def g(x,a):
#   return a-x
#
# print('a = %d' %a)
# a = g(x,a)
# print('a is now = %d' %a)

# a = 5
# x = 2
#
# #method 2: global variable
# def f(x):
#   global a
#   a = a-x
#   #return a
#
# print('a = %d' %a)
# f(x)
# print('a is now = %d' %a)
#
# sys.exit()
#
# print('hello')

####################################

# matplotlib demo
# viewing and histogram equalization of images



########################################################################################
###### Histogram equalization #######
########################################################################################
# import matplotlib.pyplot as plt # matplotlib = python plotting library
# import matplotlib.image as mpimg # image viewing
# import numpy as np
# from copy import deepcopy
# import numpy as np
# import sys
# import matplotlib.ticker as ticker
#
# #plt.clf() #clears current figure
# f = mpimg.imread('Image_Process/low_contrast.png') # read in image
# fog = deepcopy(f)
# f = 255*f.astype(float) # my image needs to be rescaled
# m = np.amax(f) #check max and min values
# mn = np.amin(f) #ditto
# print('max = ', m)
# print('min = ', mn)

# # create histogram of values
# g = f.astype("uint8")
# L = []
# for i in range(256):
#   L.append(np.sum(g == i))
#
# plt.rcdefaults()
# objects = [i for i in range(256)]
# y_pos = np.arange(len(objects))
#
# plt.bar(y_pos, L, align='center', alpha=0.75, color = 'b')
# #plt.xticks(y_pos, objects)
# plt.ylabel('Bin Counts')
# plt.xlabel('Intensity bins')
# plt.title('Histogram of Intensities')
#
# ax = plt.axes()
# ax.xaxis.set_major_locator(ticker.MultipleLocator(16))
# ax.xaxis.set_minor_locator(ticker.MultipleLocator(4))
# plt.show()


#sys.exit() # break out of script at this point


############ ***** Histogram using Hist ***** ##############
# import matplotlib.ticker as ticker
# import matplotlib.pyplot as plt # matplotlib = python plotting library
# import matplotlib.image as mpimg # image viewing
# from copy import deepcopy; import numpy as np; import sys
#
# #plt.clf() #clears current figure
# f = mpimg.imread('Image_Process/low_contrast.png') # read in image
# fog = deepcopy(f)
# f = 255*f.astype(float) # my image needs to be rescaled
# m = np.amax(f) #check max and min values
# mn = np.amin(f) #ditto
# print('max = ', m); print('min = ', mn)
#
# def G(x):
#   return ((x-5.0)*(255.0/10.0)).astype("uint8") #return unsigned 8 bit integer
#
# fhe = G(f) #histogram equalization step
#
# # plot original image and histogram
# fig = plt.figure(1)
# a = fig.add_subplot(2,2,1) # similar to matlab subplot but arrangement is diff
# imgplot1 = plt.hist(fog.ravel(), bins=256, range=(0.0, 256.0), fc='m', ec='k', alpha = 0.75)
# #.ravel(): reshape into vector
# #fc: face color, ec: edge color, alpha: transparency
# a.set_title('histogram of original image')
#
# a = fig.add_subplot(2,2,2) # similar to matlab subplot but arrangement is diff
# imgplot2 = plt.imshow(fog, interpolation = 'nearest')
# a.set_title('original image')
#
# # plot equalized image and histogram
# a = fig.add_subplot(2,2,3) # similar to matlab subplot but arrangement is diff
# imgplot3 = plt.hist(fhe.ravel(), bins=256, range=(0.0, 256.0), fc='m', ec='k', alpha = 0.75)
# #.ravel(): reshape into vector
# #fc: face color, ec: edge color, alpha: transparency
# a.set_title('histogram of equalized image')
#
# a = fig.add_subplot(2,2,4) # similar to matlab subplot but arrangement is diff
# imgplot4 = plt.imshow(fhe, interpolation = 'nearest')
# a.set_title('original image')
# plt.show()
#
# sys.exit()





### Automatic Histogram Equalization
import matplotlib.ticker as ticker
import matplotlib.pyplot as plt # matplotlib = python plotting library
import matplotlib.image as mpimg # image viewing
from copy import deepcopy; import numpy as np; import sys

#plt.clf() #clears current figure
#f = mpimg.imread('Image_Process/low_contrast.png') # read in image
f = mpimg.imread('Image_Process/factory.jpg') # read in image

fog = deepcopy(f)
f = f.astype(float) # my image needs to be rescaled
m = np.amax(f) #check max and min values
mn = np.amin(f) #ditto
print('max = ', m); print('min = ', mn)

fr = f[:,:,0]
fg = f[:,:,1]
fb = f[:,:,2]

def my_histcounts(G):
  L = np.arange(256);
  for i in range(256):
    L[i] = np.sum(G == i)
  return L

def my_histeq(F):
  Sz = f.shape
  M, N = Sz[0], Sz[1]
  n = my_histcounts(F)
  G = deepcopy(F)
  T = ((256-1)/(M*N))*np.cumsum(n)
  T = np.round(T)
  for i in range(M):
    for j in range(N):
      G[i,j] = T[F[i,j].astype("uint8")]
  return G.astype("uint8")


frhe = my_histeq(fr) #histogram equalization step
fghe = my_histeq(fg) #histogram equalization step
fbhe = my_histeq(fb) #histogram equalization step

fhe = deepcopy(fog);
fhe[:,:,0], fhe[:,:,1], fhe[:,:,2] = frhe, fghe, fbhe

Fcd = np.cumsum(my_histcounts(fhe))

# plot original image and histogram
fig = plt.figure(1)
a = fig.add_subplot(2,2,1) # similar to matlab subplot but arrangement is diff
imgplot1 = plt.hist(fog.ravel(), bins=256, range=(0.0, 256.0), fc='m', ec='k', alpha = 0.75)
#.ravel(): reshape into vector
#fc: face color, ec: edge color, alpha: transparency
a.set_title('histogram of original image')

a = fig.add_subplot(2,2,2) # similar to matlab subplot but arrangement is diff
imgplot2 = plt.imshow(fog, interpolation = 'nearest')
a.set_title('original image')

# plot equalized image and histogram
a = fig.add_subplot(2,2,3) # similar to matlab subplot but arrangement is diff
imgplot3 = plt.hist(fhe.ravel(), bins=256, range=(0, 256), fc='m', ec='k', alpha = 0.75)
#.ravel(): reshape into vector
#fc: face color, ec: edge color, alpha: transparency
a.set_title('histogram of equalized image')

a = fig.add_subplot(2,2,4) # similar to matlab subplot but arrangement is diff
imgplot4 = plt.imshow(fhe, interpolation = 'nearest')
a.set_title('original image')
plt.show()

sys.exit()







# create histogram of values
g = fhe.astype("uint8")
L = np.arange(256);
for i in range(256):
  L[i] = np.sum(g == i)

#plt.rcdefaults()
plt.rcdefaults() # release candidate default settings

y_pos = np.arange(256)
print('length of y_pos is = %d' %len(y_pos))

##bar chart of the data
#plt.bar(y_pos, L, align='center', alpha=0.75, color = 'b')
# ax = plt.axes()
# ax.xaxis.set_major_locator(ticker.MultipleLocator(16))
# ax.xaxis.set_minor_locator(ticker.MultipleLocator(4))

# the histogram of the data
# plt.hist(fhe.ravel(), bins=256, range=(0.0, 256.0), fc='m', ec='k', alpha = 0.75)
# plt.ylabel('Bin Counts')
# plt.xlabel('Intensity bins')
# plt.title('Histogram of Intensities')



fig = plt.figure(2)
a = fig.add_subplot(1,2,1) # similar to matlab subplot but arrangement is diff
imgplot = plt.hist(fhe.ravel(), bins=256, range=(0.0, 256.0), fc='m', ec='k', alpha = 0.75)
#.ravel(): reshape into vector
#fc: face color, ec: edge color, alpha: transparency
a.set_title('histogram')

a = fig.add_subplot(1,2,2) # similar to matlab subplot but arrangement is diff
imgplot = plt.imshow(fhe, interpolation = 'none')
a.set_title('histogram equalized image')

# plt.ylabel('Bin Counts')
# plt.xlabel('Intensity bins')
# plt.title('Histogram of Intensities')

plt.show()


sys.exit()

plt.show(block=False) #displays figure, if block = True, enter gui backend, figure close to stop the blocking
plt.pause(1)#needed or else figure does not show
input("<Hit Enter To Show Result>")
plt.close(fig)
#plt.clf()

fig = plt.figure(1)
a = fig.add_subplot(1,2,1) # similar to matlab subplot but arrangement is diff
imgplot = plt.imshow(f.astype("uint8"))
a.set_title('Original Image')
a = fig.add_subplot(1,2,2)
imgplot = plt.imshow(fhe)
a.set_title('Equalized Image')

#plt.show(block=False) #displays figure, if block = True, enter gui backend, figure close to stop the blocking
plt.show(block=True) #displays figure, if block = True, enter gui backend, figure close to stop the blocking
#plt.pause(1) #needed or else figure does not show
#input("<Hit Enter To Close>")
#
# plt.close(fig)


########################################################################################



### downsample image ###
# import matplotlib.pyplot as plt # matplotlib = python plotting library
# import matplotlib.image as mpimg # image viewing
#
# import numpy as np
# plt.clf() #clears current figure
# img = mpimg.imread('Image_Process/cowbell.jpg') # read in image
# fig = plt.figure(1)
#
# img2 = img[::2,::2,:]
# img3 = img2[::4,::4,:]
#
# a = fig.add_subplot(1,3,1) # similar to matlab subplot but arrangement is diff
# imgplot = plt.imshow(img, interpolation = 'nearest')
# a.set_title('OG image')
#
# a = fig.add_subplot(1,3,2) # similar to matlab subplot but arrangement is diff
# imgplot = plt.imshow(img2, interpolation = 'nearest')
# a.set_title('downsample 2x')
#
# a = fig.add_subplot(1,3,3) # similar to matlab subplot but arrangement is diff
# imgplot = plt.imshow(img3, interpolation = 'nearest')
# a.set_title('downsample 8x')
#
#
# plt.show(block=False) #displays figure, if block = True, enter gui backend, figure close to stop the blocking
# plt.pause(1) #needed or else figure does not show
# input("<Hit Enter To Close>")
# plt.close(fig)
#####
